//: DYNATEST.CPP -- test program for template dynarray.
//. From "Using C++, 2nd edition"
//. by Bruce Eckel (Osborne/McGraw-Hill 1992)
#include "dynarray.h"
#include "ostring.h"

void main() {
  DynArray<String> da;
  da.add(new String("This is a "));
  da.add(new String("test of the "));
  da.add(new String("dynamic array "));
  da.add(new String("class "));
  da.add(new String("to \n"));
  da.add(new String("(OOPS! A Mistake) "));
  da.add(new String("see "));
  da.add(new String("if "));
  da.add(new String("it "));
  da.add(new String("will "));
  da.add(new String("automatically make "));
  da.add(new String("itself bigger "));
  da.add(new String("when it \n"));
  da.add(new String("runs out of "));
  da.add(new String("room."));
  // First, print the whole list:
  da.reset();
  do
    cout << *da.current();
  while( da.next() );
  cout << endl << endl;
  // Now, find the element with the "OOPS":
  da.reset();
  while( strstr(*da.current(), "OOPS") == 0 )
    if(da.next() == 0) {
      cerr << "OOPS not found" << endl;
      exit(1);
    }
  int rm = da.index(); // number of element to remove
  cout << "removing " << *da[rm] << endl;
  if (da.remove(rm))
    cout << "removed successfully!" << endl;
  // Print the whole list again:
  da.reset();
  do
    cout << *da.current();
  while( da.next() );
}
