//: OSTRING.H -- very simple string class
//. Adapted from "Using C++" 2nd edition, Osborne/McGraw-Hill 1992
//. by Bruce Eckel
#ifndef OSTRING_H_
#define OSTRING_H_
#include <string.h>
#include <stdlib.h>
#include <iostream.h>

class String {
  char *s;
public:
  String(char * S = "") : s(strdup(S)) {}
  // copy constructor:
  String(String& rv) : s(strdup(rv.s)) {}
  void operator=(char* S) {
    free(s);
    s = strdup(S);
  }
  ~String() { free(s); }
  operator char*() { return s; }
  friend ostream&
    operator<<(ostream& os, String& S) {
    return os << S.s;
  }
};

#endif // OSTRING_H_
